﻿using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.IO;


namespace Moswar
{
    class StrDecoder
    {
        public static void scanStrings()
        {
            //1.
            //fix regex for your case
            //

            string RegPattern = @"c000013\.m00007e\x28(?<code>.+?)\x29";
            Dictionary<string, string> dict = new Dictionary<string, string>();

            string encodedStringsFileList = "in.txt";
            if (!File.Exists(encodedStringsFileList))
                return;
            string s = File.ReadAllText(encodedStringsFileList);

            RegexOptions options = new RegexOptions();
            options |= RegexOptions.Multiline;
            options |= RegexOptions.IgnoreCase;
            Regex taskregex = new Regex(RegPattern, options);
            MatchCollection theMatches = taskregex.Matches(s);

            int dubl = 0, strange = 0;
            foreach (Match m in theMatches)
            {
                //if (m.Success)
                {
                    string val = m.Groups["code"].Value;
                    //int hexVal = Convert.ToInt32(val, 16);
                    int hexVal = Convert.ToInt32(val);

                    //2.
                    //put here a call to string decoder API
                    //

                    string str = c000013.m00007e(hexVal);       
                    //Console.WriteLine(str);

                    if (str.Contains("\\"))
                        str = str.Replace("\\", "\\\\");
                    if (str.Contains("\""))
                        str = str.Replace("\"", "\\\"");
                    if (str.Contains("\r"))
                        str = str.Replace("\r", "\\r");
                    if (str.Contains("\n"))
                        str = str.Replace("\n", "\\n");
                    if (str.Contains("\0"))//yes, it happens :)
                        str = str.Replace("\0", "\\0");

                    if (!dict.ContainsKey(val))
                    {
                        dict[val] = str;
                    }
                    else
                    {
                        if (dict[val] != str)
                        {
                            ++strange;
                        }

                        ++dubl;
                    }
                }
            }

            //save to file
            string outText = "";
            foreach (KeyValuePair<string, string> el in dict)
            {
                outText += el.Key//String.Format("0x{0:x}", el.Key)
                    + "\t" + el.Value
                    + "\r\n"
                    ;
            }
            File.WriteAllText("out.txt", outText);


            RegexOptions opt = new RegexOptions();
            options |= RegexOptions.Multiline;
            options |= RegexOptions.IgnoreCase;
            options |= RegexOptions.Compiled;
            Regex regex = new Regex(RegPattern, opt);

            /* read file list from file
            StreamReader objReader = new StreamReader("cslist.txt");
            ArrayList arrText = new ArrayList();
            string sLine = "";
            while (sLine != null)
            {
                sLine = objReader.ReadLine();
                if (sLine != null)
                    arrText.Add(sLine);
            }
            objReader.Close();
            */

            /* scan all files by mask */

            string srcDir = "NS757602046";
            string[] files = Directory.GetFiles(srcDir, "*.cs", SearchOption.AllDirectories);

            foreach (string curFile in files)
            //string f = "c00019f.cs";
            {
                //string curFile = "NS757602046" + Path.DirectorySeparatorChar + f;
                string input = File.ReadAllText(curFile);

                string output = regex.Replace(input,
                            delegate(Match match)
                            {
                                string value;
                                dict.TryGetValue(match.Groups[1].Value, out value);
                                //very slow!
                                //Console.WriteLine(match.Groups[0].Value + ", " + match.Groups[1].Value + " -> " + value);
                                return "\"" + value + "\"";
                            }
                            );

                File.WriteAllText(curFile, output);
            }
        }
    }
}
